

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>pywws.Plot &mdash; pywws v12.10 documentation</title>
    <link rel="stylesheet" href="../../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../../',
        VERSION:     '12.10',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../_static/doctools.js"></script>
    <link rel="shortcut icon" href="../../_static/pywws_logo.ico"/>
    <link rel="top" title="pywws v12.10 documentation" href="../../index.html" />
    <link rel="up" title="Module code" href="../index.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li><a href="../../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="../index.html" accesskey="U">Module code</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <h1>Source code for pywws.Plot</h1><div class="highlight"><pre>
<span class="c">#!/usr/bin/env python</span>

<span class="sd">&quot;&quot;&quot;</span>
<span class="sd">Plot graphs of weather data according to an XML recipe.</span>

<span class="sd">usage: python Plot.py [options] data_dir temp_dir xml_file output_file</span>
<span class="sd">options are:</span>
<span class="sd">\t-h or --help\t\tdisplay this help</span>
<span class="sd">data_dir is the root directory of the weather data</span>
<span class="sd">temp_dir is a workspace for temporary files e.g. /tmp</span>
<span class="sd">xml_file is the name of the source file that describes the plot</span>
<span class="sd">output_file is the name of the image file to be created e.g. 24hrs.png</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">import</span> <span class="nn">codecs</span>
<span class="kn">from</span> <span class="nn">datetime</span> <span class="kn">import</span> <span class="n">datetime</span><span class="p">,</span> <span class="n">timedelta</span>
<span class="kn">import</span> <span class="nn">getopt</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">subprocess</span>
<span class="kn">import</span> <span class="nn">sys</span>
<span class="kn">import</span> <span class="nn">xml.dom.minidom</span>

<span class="kn">from</span> <span class="nn">conversions</span> <span class="kn">import</span> <span class="o">*</span>
<span class="kn">import</span> <span class="nn">DataStore</span>
<span class="kn">import</span> <span class="nn">Localisation</span>
<span class="kn">from</span> <span class="nn">TimeZone</span> <span class="kn">import</span> <span class="n">Local</span>
<span class="kn">from</span> <span class="nn">WeatherStation</span> <span class="kn">import</span> <span class="n">dew_point</span><span class="p">,</span> <span class="n">wind_chill</span><span class="p">,</span> <span class="n">apparent_temp</span>

<div class="viewcode-block" id="BasePlotter"><a class="viewcode-back" href="../../api/pywws.Plot.html#pywws.Plot.BasePlotter">[docs]</a><span class="k">class</span> <span class="nc">BasePlotter</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">params</span><span class="p">,</span> <span class="n">raw_data</span><span class="p">,</span> <span class="n">hourly_data</span><span class="p">,</span>
                 <span class="n">daily_data</span><span class="p">,</span> <span class="n">monthly_data</span><span class="p">,</span> <span class="n">work_dir</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">raw_data</span> <span class="o">=</span> <span class="n">raw_data</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">hourly_data</span> <span class="o">=</span> <span class="n">hourly_data</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">daily_data</span> <span class="o">=</span> <span class="n">daily_data</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">monthly_data</span> <span class="o">=</span> <span class="n">monthly_data</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">work_dir</span> <span class="o">=</span> <span class="n">work_dir</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">pressure_offset</span> <span class="o">=</span> <span class="nb">eval</span><span class="p">(</span><span class="n">params</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s">&#39;fixed&#39;</span><span class="p">,</span> <span class="s">&#39;pressure offset&#39;</span><span class="p">))</span>
        <span class="c"># set language related stuff</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">encoding</span> <span class="o">=</span> <span class="n">params</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s">&#39;config&#39;</span><span class="p">,</span> <span class="s">&#39;gnuplot encoding&#39;</span><span class="p">,</span> <span class="s">&#39;iso_8859_1&#39;</span><span class="p">)</span>
        <span class="c"># create work directory</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">isdir</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">work_dir</span><span class="p">):</span>
            <span class="n">os</span><span class="o">.</span><span class="n">makedirs</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">work_dir</span><span class="p">)</span>

<div class="viewcode-block" id="BasePlotter.DoPlot"><a class="viewcode-back" href="../../api/pywws.Plot.html#pywws.Plot.BasePlotter.DoPlot">[docs]</a>    <span class="k">def</span> <span class="nf">DoPlot</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">input_file</span><span class="p">,</span> <span class="n">output_file</span><span class="p">):</span>
        <span class="c"># read XML graph description</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">doc</span> <span class="o">=</span> <span class="n">xml</span><span class="o">.</span><span class="n">dom</span><span class="o">.</span><span class="n">minidom</span><span class="o">.</span><span class="n">parse</span><span class="p">(</span><span class="n">input_file</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">graph</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">doc</span><span class="o">.</span><span class="n">childNodes</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
        <span class="c"># get list of plots</span>
        <span class="n">plot_list</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetPlotList</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">plot_count</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">plot_list</span><span class="p">)</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">plot_count</span> <span class="o">&lt;</span> <span class="mi">1</span><span class="p">:</span>
            <span class="c"># nothing to plot</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">doc</span><span class="o">.</span><span class="n">unlink</span><span class="p">()</span>
            <span class="k">return</span> <span class="mi">1</span>
        <span class="c"># get start and end datetimes</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">x_lo</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">graph</span><span class="p">,</span> <span class="s">&#39;start&#39;</span><span class="p">,</span> <span class="bp">None</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">graph</span><span class="p">,</span> <span class="s">&#39;stop&#39;</span><span class="p">,</span> <span class="bp">None</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">duration</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">graph</span><span class="p">,</span> <span class="s">&#39;duration&#39;</span><span class="p">,</span> <span class="bp">None</span><span class="p">)</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">duration</span> <span class="o">==</span> <span class="bp">None</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">duration</span> <span class="o">=</span> <span class="n">timedelta</span><span class="p">(</span><span class="n">hours</span><span class="o">=</span><span class="mi">24</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">duration</span> <span class="o">=</span> <span class="nb">eval</span><span class="p">(</span><span class="s">&#39;timedelta(</span><span class="si">%s</span><span class="s">)&#39;</span> <span class="o">%</span> <span class="bp">self</span><span class="o">.</span><span class="n">duration</span><span class="p">)</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_lo</span> <span class="o">!=</span> <span class="bp">None</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">x_lo</span> <span class="o">=</span> <span class="nb">eval</span><span class="p">(</span><span class="s">&#39;datetime(</span><span class="si">%s</span><span class="s">)&#39;</span> <span class="o">%</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_lo</span><span class="p">)</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span> <span class="o">!=</span> <span class="bp">None</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span> <span class="o">=</span> <span class="nb">eval</span><span class="p">(</span><span class="s">&#39;datetime(</span><span class="si">%s</span><span class="s">)&#39;</span> <span class="o">%</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span><span class="p">)</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">duration</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span> <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_lo</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_lo</span> <span class="o">+</span> <span class="bp">self</span><span class="o">.</span><span class="n">duration</span>
        <span class="k">elif</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span> <span class="o">!=</span> <span class="bp">None</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span> <span class="o">=</span> <span class="nb">eval</span><span class="p">(</span><span class="s">&#39;datetime(</span><span class="si">%s</span><span class="s">)&#39;</span> <span class="o">%</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">x_lo</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span> <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">duration</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">hourly_data</span><span class="o">.</span><span class="n">before</span><span class="p">(</span><span class="n">datetime</span><span class="o">.</span><span class="n">max</span><span class="p">)</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span> <span class="o">==</span> <span class="bp">None</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span> <span class="o">=</span> <span class="n">datetime</span><span class="o">.</span><span class="n">utcnow</span><span class="p">()</span>    <span class="c"># only if no hourly data</span>
            <span class="c"># set end of graph to start of the next hour after last item</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span> <span class="o">+</span> <span class="n">timedelta</span><span class="p">(</span><span class="n">minutes</span><span class="o">=</span><span class="mi">55</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="n">minute</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">second</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">x_lo</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span> <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">duration</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span> <span class="o">+</span> <span class="n">Local</span><span class="o">.</span><span class="n">utcoffset</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x_lo</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">x_lo</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span> <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">duration</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">utcoffset</span> <span class="o">=</span> <span class="n">Local</span><span class="o">.</span><span class="n">utcoffset</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x_lo</span><span class="p">)</span>
        <span class="c"># open gnuplot command file</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">tmp_files</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="n">cmd_file</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">work_dir</span><span class="p">,</span> <span class="s">&#39;plot.cmd&#39;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">tmp_files</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">cmd_file</span><span class="p">)</span>
        <span class="n">of</span> <span class="o">=</span> <span class="nb">open</span><span class="p">(</span><span class="n">cmd_file</span><span class="p">,</span> <span class="s">&#39;w&#39;</span><span class="p">)</span>
        <span class="c"># write gnuplot set up</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">rows</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetDefaultRows</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">cols</span> <span class="o">=</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">plot_count</span> <span class="o">+</span> <span class="bp">self</span><span class="o">.</span><span class="n">rows</span> <span class="o">-</span> <span class="mi">1</span><span class="p">)</span> <span class="o">/</span> <span class="bp">self</span><span class="o">.</span><span class="n">rows</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">rows</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">cols</span> <span class="o">=</span> <span class="nb">eval</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">graph</span><span class="p">,</span> <span class="s">&#39;layout&#39;</span><span class="p">,</span> <span class="s">&#39;</span><span class="si">%d</span><span class="s">, </span><span class="si">%d</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">rows</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">cols</span><span class="p">)))</span>
        <span class="n">w</span><span class="p">,</span> <span class="n">h</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetDefaultPlotSize</span><span class="p">()</span>
        <span class="n">w</span> <span class="o">=</span> <span class="n">w</span> <span class="o">*</span> <span class="bp">self</span><span class="o">.</span><span class="n">cols</span>
        <span class="n">h</span> <span class="o">=</span> <span class="n">h</span> <span class="o">*</span> <span class="bp">self</span><span class="o">.</span><span class="n">rows</span>
        <span class="n">w</span><span class="p">,</span> <span class="n">h</span> <span class="o">=</span> <span class="nb">eval</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">graph</span><span class="p">,</span> <span class="s">&#39;size&#39;</span><span class="p">,</span> <span class="s">&#39;(</span><span class="si">%d</span><span class="s">, </span><span class="si">%d</span><span class="s">)&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">w</span><span class="p">,</span> <span class="n">h</span><span class="p">)))</span>
        <span class="n">fileformat</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">graph</span><span class="p">,</span> <span class="s">&#39;fileformat&#39;</span><span class="p">,</span> <span class="s">&#39;png&#39;</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">fileformat</span> <span class="o">==</span> <span class="s">&#39;svg&#39;</span><span class="p">:</span>
            <span class="n">terminal</span> <span class="o">=</span> <span class="s">&#39;</span><span class="si">%s</span><span class="s"> enhanced font &quot;arial,9&quot; size </span><span class="si">%d</span><span class="s">,</span><span class="si">%d</span><span class="s"> dynamic rounded&#39;</span> <span class="o">%</span> <span class="p">(</span>
                <span class="n">fileformat</span><span class="p">,</span> <span class="n">w</span><span class="p">,</span> <span class="n">h</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">terminal</span> <span class="o">=</span> <span class="s">&#39;</span><span class="si">%s</span><span class="s"> large size </span><span class="si">%d</span><span class="s">,</span><span class="si">%d</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">fileformat</span><span class="p">,</span> <span class="n">w</span><span class="p">,</span> <span class="n">h</span><span class="p">)</span>
        <span class="n">terminal</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">graph</span><span class="p">,</span> <span class="s">&#39;terminal&#39;</span><span class="p">,</span> <span class="n">terminal</span><span class="p">)</span>
        <span class="n">of</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="s">&#39;set encoding </span><span class="si">%s</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">encoding</span><span class="p">))</span>
        <span class="n">of</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="s">&#39;set terminal </span><span class="si">%s</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">terminal</span><span class="p">))</span>
        <span class="n">of</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="s">&#39;set output &quot;</span><span class="si">%s</span><span class="s">&quot;</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">output_file</span><span class="p">))</span>
        <span class="c"># set overall title</span>
        <span class="n">title</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">graph</span><span class="p">,</span> <span class="s">&#39;title&#39;</span><span class="p">,</span> <span class="s">&#39;&#39;</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">title</span><span class="p">:</span>
            <span class="n">title</span> <span class="o">=</span> <span class="n">title</span><span class="o">.</span><span class="n">encode</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">encoding</span><span class="p">)</span>
            <span class="n">title</span> <span class="o">=</span> <span class="s">&#39;title &quot;</span><span class="si">%s</span><span class="s">&quot;&#39;</span> <span class="o">%</span> <span class="n">title</span>
        <span class="n">of</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="s">&#39;set multiplot layout </span><span class="si">%d</span><span class="s">, </span><span class="si">%d</span><span class="s"> </span><span class="si">%s</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">rows</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">cols</span><span class="p">,</span> <span class="n">title</span><span class="p">))</span>
        <span class="c"># do actual plots</span>
        <span class="n">of</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">GetPreamble</span><span class="p">())</span>
        <span class="k">for</span> <span class="n">plot_no</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">plot_count</span><span class="p">):</span>
            <span class="n">plot</span> <span class="o">=</span> <span class="n">plot_list</span><span class="p">[</span><span class="n">plot_no</span><span class="p">]</span>
            <span class="c"># set key / title location</span>
            <span class="n">title</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="n">plot</span><span class="p">,</span> <span class="s">&#39;title&#39;</span><span class="p">,</span> <span class="s">&#39;&#39;</span><span class="p">)</span>
            <span class="n">title</span> <span class="o">=</span> <span class="n">title</span><span class="o">.</span><span class="n">encode</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">encoding</span><span class="p">)</span>
            <span class="n">of</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="s">&#39;set key horizontal title &quot;</span><span class="si">%s</span><span class="s">&quot;</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="n">title</span><span class="p">)</span>
            <span class="c"># optional yaxis labels</span>
            <span class="n">ylabel</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="n">plot</span><span class="p">,</span> <span class="s">&#39;ylabel&#39;</span><span class="p">,</span> <span class="s">&#39;&#39;</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">ylabel</span><span class="p">:</span>
                <span class="n">ylabel</span> <span class="o">=</span> <span class="n">ylabel</span><span class="o">.</span><span class="n">encode</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">encoding</span><span class="p">)</span>
                <span class="n">ylabelangle</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="n">plot</span><span class="p">,</span> <span class="s">&#39;ylabelangle&#39;</span><span class="p">,</span> <span class="s">&#39;&#39;</span><span class="p">)</span>
                <span class="k">if</span> <span class="n">ylabelangle</span><span class="p">:</span>
                    <span class="n">ylabelangle</span> <span class="o">=</span> <span class="s">&#39; rotate by </span><span class="si">%s</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">ylabelangle</span><span class="p">)</span>
                <span class="n">of</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="s">&#39;set ylabel &quot;</span><span class="si">%s</span><span class="s">&quot;</span><span class="si">%s</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">ylabel</span><span class="p">,</span> <span class="n">ylabelangle</span><span class="p">))</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">of</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="s">&#39;set ylabel</span><span class="se">\n</span><span class="s">&#39;</span><span class="p">)</span>
            <span class="n">y2label</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="n">plot</span><span class="p">,</span> <span class="s">&#39;y2label&#39;</span><span class="p">,</span> <span class="s">&#39;&#39;</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">y2label</span><span class="p">:</span>
                <span class="n">y2label</span> <span class="o">=</span> <span class="n">y2label</span><span class="o">.</span><span class="n">encode</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">encoding</span><span class="p">)</span>
                <span class="n">y2labelangle</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="n">plot</span><span class="p">,</span> <span class="s">&#39;y2labelangle&#39;</span><span class="p">,</span> <span class="s">&#39;&#39;</span><span class="p">)</span>
                <span class="k">if</span> <span class="n">y2labelangle</span><span class="p">:</span>
                    <span class="n">y2labelangle</span> <span class="o">=</span> <span class="s">&#39; rotate by </span><span class="si">%s</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">y2labelangle</span><span class="p">)</span>
                <span class="n">of</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="s">&#39;set y2label &quot;</span><span class="si">%s</span><span class="s">&quot;</span><span class="si">%s</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">y2label</span><span class="p">,</span> <span class="n">y2labelangle</span><span class="p">))</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">of</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="s">&#39;set y2label</span><span class="se">\n</span><span class="s">&#39;</span><span class="p">)</span>
            <span class="c"># set data source</span>
            <span class="n">source</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="n">plot</span><span class="p">,</span> <span class="s">&#39;source&#39;</span><span class="p">,</span> <span class="s">&#39;raw&#39;</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">source</span> <span class="o">==</span> <span class="s">&#39;raw&#39;</span><span class="p">:</span>
                <span class="n">source</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">raw_data</span>
            <span class="k">elif</span> <span class="n">source</span> <span class="o">==</span> <span class="s">&#39;hourly&#39;</span><span class="p">:</span>
                <span class="n">source</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">hourly_data</span>
            <span class="k">elif</span> <span class="n">source</span> <span class="o">==</span> <span class="s">&#39;monthly&#39;</span><span class="p">:</span>
                <span class="n">source</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">monthly_data</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">source</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">daily_data</span>
            <span class="c"># do the plot</span>
            <span class="n">of</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">PlotData</span><span class="p">(</span><span class="n">plot_no</span><span class="p">,</span> <span class="n">plot</span><span class="p">,</span> <span class="n">source</span><span class="p">))</span>
        <span class="n">of</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">doc</span><span class="o">.</span><span class="n">unlink</span><span class="p">()</span>
        <span class="c"># run gnuplot on file</span>
        <span class="n">subprocess</span><span class="o">.</span><span class="n">check_call</span><span class="p">([</span><span class="s">&#39;gnuplot&#39;</span><span class="p">,</span> <span class="n">cmd_file</span><span class="p">])</span>
        <span class="k">for</span> <span class="nb">file</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">tmp_files</span><span class="p">:</span>
            <span class="n">os</span><span class="o">.</span><span class="n">unlink</span><span class="p">(</span><span class="nb">file</span><span class="p">)</span>
        <span class="k">return</span> <span class="mi">0</span>
</div>
<div class="viewcode-block" id="BasePlotter.GetChildren"><a class="viewcode-back" href="../../api/pywws.Plot.html#pywws.Plot.BasePlotter.GetChildren">[docs]</a>    <span class="k">def</span> <span class="nf">GetChildren</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">node</span><span class="p">,</span> <span class="n">name</span><span class="p">):</span>
        <span class="n">result</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">child</span> <span class="ow">in</span> <span class="n">node</span><span class="o">.</span><span class="n">childNodes</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">child</span><span class="o">.</span><span class="n">localName</span> <span class="o">==</span> <span class="n">name</span><span class="p">:</span>
                <span class="n">result</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">child</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">result</span>
</div>
<div class="viewcode-block" id="BasePlotter.GetValue"><a class="viewcode-back" href="../../api/pywws.Plot.html#pywws.Plot.BasePlotter.GetValue">[docs]</a>    <span class="k">def</span> <span class="nf">GetValue</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">node</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">default</span><span class="p">):</span>
        <span class="k">for</span> <span class="n">child</span> <span class="ow">in</span> <span class="n">node</span><span class="o">.</span><span class="n">childNodes</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">child</span><span class="o">.</span><span class="n">localName</span> <span class="o">==</span> <span class="n">name</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">child</span><span class="o">.</span><span class="n">childNodes</span><span class="p">:</span>
                    <span class="k">return</span> <span class="n">child</span><span class="o">.</span><span class="n">childNodes</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="k">return</span> <span class="s">&#39;&#39;</span>
        <span class="k">return</span> <span class="n">default</span>
</div></div>
<div class="viewcode-block" id="Record"><a class="viewcode-back" href="../../api/pywws.Plot.html#pywws.Plot.Record">[docs]</a><span class="k">class</span> <span class="nc">Record</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
    <span class="k">pass</span>
</div>
<div class="viewcode-block" id="GraphPlotter"><a class="viewcode-back" href="../../api/pywws.Plot.html#pywws.Plot.GraphPlotter">[docs]</a><span class="k">class</span> <span class="nc">GraphPlotter</span><span class="p">(</span><span class="n">BasePlotter</span><span class="p">):</span>
<div class="viewcode-block" id="GraphPlotter.GetPlotList"><a class="viewcode-back" href="../../api/pywws.Plot.html#pywws.Plot.GraphPlotter.GetPlotList">[docs]</a>    <span class="k">def</span> <span class="nf">GetPlotList</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetChildren</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">graph</span><span class="p">,</span> <span class="s">&#39;plot&#39;</span><span class="p">)</span>
</div>
<div class="viewcode-block" id="GraphPlotter.GetDefaultRows"><a class="viewcode-back" href="../../api/pywws.Plot.html#pywws.Plot.GraphPlotter.GetDefaultRows">[docs]</a>    <span class="k">def</span> <span class="nf">GetDefaultRows</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">plot_count</span>
</div>
<div class="viewcode-block" id="GraphPlotter.GetDefaultPlotSize"><a class="viewcode-back" href="../../api/pywws.Plot.html#pywws.Plot.GraphPlotter.GetDefaultPlotSize">[docs]</a>    <span class="k">def</span> <span class="nf">GetDefaultPlotSize</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="mi">200</span> <span class="o">/</span> <span class="bp">self</span><span class="o">.</span><span class="n">cols</span><span class="p">,</span> <span class="mi">600</span> <span class="o">/</span> <span class="bp">self</span><span class="o">.</span><span class="n">cols</span>
</div>
<div class="viewcode-block" id="GraphPlotter.GetPreamble"><a class="viewcode-back" href="../../api/pywws.Plot.html#pywws.Plot.GraphPlotter.GetPreamble">[docs]</a>    <span class="k">def</span> <span class="nf">GetPreamble</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="n">result</span> <span class="o">=</span> <span class="s">&quot;&quot;&quot;set style fill solid</span>
<span class="s">set xdata time</span>
<span class="s">set timefmt &quot;%Y-%m-</span><span class="si">%d</span><span class="s">T%H:%M:%S&quot;</span>
<span class="s">&quot;&quot;&quot;</span>
        <span class="n">result</span> <span class="o">+=</span> <span class="s">&#39;set xrange [&quot;</span><span class="si">%s</span><span class="s">&quot;:&quot;</span><span class="si">%s</span><span class="s">&quot;]</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">x_lo</span><span class="o">.</span><span class="n">isoformat</span><span class="p">(),</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span><span class="o">.</span><span class="n">isoformat</span><span class="p">())</span>
        <span class="n">lmargin</span> <span class="o">=</span> <span class="nb">eval</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">graph</span><span class="p">,</span> <span class="s">&#39;lmargin&#39;</span><span class="p">,</span> <span class="s">&#39;5&#39;</span><span class="p">))</span>
        <span class="n">result</span> <span class="o">+=</span> <span class="s">&#39;set lmargin </span><span class="si">%g</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">lmargin</span><span class="p">)</span>
        <span class="n">rmargin</span> <span class="o">=</span> <span class="nb">eval</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">graph</span><span class="p">,</span> <span class="s">&#39;rmargin&#39;</span><span class="p">,</span> <span class="s">&#39;-1&#39;</span><span class="p">))</span>
        <span class="n">result</span> <span class="o">+=</span> <span class="s">&#39;set rmargin </span><span class="si">%g</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">rmargin</span><span class="p">)</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">duration</span> <span class="o">&lt;=</span> <span class="n">timedelta</span><span class="p">(</span><span class="n">hours</span><span class="o">=</span><span class="mi">24</span><span class="p">):</span>
            <span class="n">xformat</span> <span class="o">=</span> <span class="s">&#39;%H%M&#39;</span>
        <span class="k">elif</span> <span class="bp">self</span><span class="o">.</span><span class="n">duration</span> <span class="o">&lt;=</span> <span class="n">timedelta</span><span class="p">(</span><span class="n">days</span><span class="o">=</span><span class="mi">7</span><span class="p">):</span>
            <span class="n">xformat</span> <span class="o">=</span> <span class="s">&#39;%a </span><span class="si">%d</span><span class="s">&#39;</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">xformat</span> <span class="o">=</span> <span class="s">&#39;%Y/%m/</span><span class="si">%d</span><span class="s">&#39;</span>
        <span class="n">xformat</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">graph</span><span class="p">,</span> <span class="s">&#39;xformat&#39;</span><span class="p">,</span> <span class="n">xformat</span><span class="p">)</span>
        <span class="n">result</span> <span class="o">+=</span> <span class="s">&#39;set format x &quot;</span><span class="si">%s</span><span class="s">&quot;</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="n">xformat</span>
        <span class="n">xtics</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">graph</span><span class="p">,</span> <span class="s">&#39;xtics&#39;</span><span class="p">,</span> <span class="bp">None</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">xtics</span><span class="p">:</span>
            <span class="n">result</span> <span class="o">+=</span> <span class="s">&#39;set xtics </span><span class="si">%d</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="nb">eval</span><span class="p">(</span><span class="n">xtics</span><span class="p">)</span> <span class="o">*</span> <span class="mi">3600</span><span class="p">)</span>
        <span class="n">result</span> <span class="o">=</span> <span class="n">result</span><span class="o">.</span><span class="n">encode</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">encoding</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">result</span>
</div>
<div class="viewcode-block" id="GraphPlotter.PlotData"><a class="viewcode-back" href="../../api/pywws.Plot.html#pywws.Plot.GraphPlotter.PlotData">[docs]</a>    <span class="k">def</span> <span class="nf">PlotData</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">plot_no</span><span class="p">,</span> <span class="n">plot</span><span class="p">,</span> <span class="n">source</span><span class="p">):</span>
        <span class="n">_</span> <span class="o">=</span> <span class="n">Localisation</span><span class="o">.</span><span class="n">translation</span><span class="o">.</span><span class="n">ugettext</span>
        <span class="n">subplot_list</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetChildren</span><span class="p">(</span><span class="n">plot</span><span class="p">,</span> <span class="s">&#39;subplot&#39;</span><span class="p">)</span>
        <span class="n">subplot_count</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">subplot_list</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">subplot_count</span> <span class="o">&lt;</span> <span class="mi">1</span><span class="p">:</span>
            <span class="k">return</span> <span class="s">&#39;&#39;</span>
        <span class="n">result</span> <span class="o">=</span> <span class="s">&#39;&#39;</span>
        <span class="n">pressure_offset</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">pressure_offset</span>
        <span class="c"># label x axis of last plot</span>
        <span class="k">if</span> <span class="n">plot_no</span> <span class="o">==</span> <span class="bp">self</span><span class="o">.</span><span class="n">plot_count</span> <span class="o">-</span> <span class="mi">1</span><span class="p">:</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">duration</span> <span class="o">&lt;=</span> <span class="n">timedelta</span><span class="p">(</span><span class="n">hours</span><span class="o">=</span><span class="mi">24</span><span class="p">):</span>
                <span class="n">xlabel</span> <span class="o">=</span> <span class="n">_</span><span class="p">(</span><span class="s">&#39;Time (%Z)&#39;</span><span class="p">)</span>
            <span class="k">elif</span> <span class="bp">self</span><span class="o">.</span><span class="n">duration</span> <span class="o">&lt;=</span> <span class="n">timedelta</span><span class="p">(</span><span class="n">days</span><span class="o">=</span><span class="mi">7</span><span class="p">):</span>
                <span class="n">xlabel</span> <span class="o">=</span> <span class="n">_</span><span class="p">(</span><span class="s">&#39;Day&#39;</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">xlabel</span> <span class="o">=</span> <span class="n">_</span><span class="p">(</span><span class="s">&#39;Date&#39;</span><span class="p">)</span>
            <span class="n">xlabel</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">graph</span><span class="p">,</span> <span class="s">&#39;xlabel&#39;</span><span class="p">,</span> <span class="n">xlabel</span><span class="p">)</span>
            <span class="n">xlabel</span> <span class="o">=</span> <span class="n">xlabel</span><span class="o">.</span><span class="n">encode</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">encoding</span><span class="p">)</span>
            <span class="n">result</span> <span class="o">+=</span> <span class="s">&#39;set xlabel &quot;</span><span class="si">%s</span><span class="s">&quot;</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">x_lo</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="n">tzinfo</span><span class="o">=</span><span class="n">Local</span><span class="p">)</span><span class="o">.</span><span class="n">strftime</span><span class="p">(</span><span class="n">xlabel</span><span class="p">))</span>
            <span class="n">dateformat</span> <span class="o">=</span> <span class="s">&#39;%Y/%m/</span><span class="si">%d</span><span class="s">&#39;</span>
            <span class="n">dateformat</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">graph</span><span class="p">,</span> <span class="s">&#39;dateformat&#39;</span><span class="p">,</span> <span class="n">dateformat</span><span class="p">)</span>
            <span class="n">dateformat</span> <span class="o">=</span> <span class="n">dateformat</span><span class="o">.</span><span class="n">encode</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">encoding</span><span class="p">)</span>
            <span class="n">ldat</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_lo</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="n">tzinfo</span><span class="o">=</span><span class="n">Local</span><span class="p">)</span><span class="o">.</span><span class="n">strftime</span><span class="p">(</span><span class="n">dateformat</span><span class="p">)</span>
            <span class="n">rdat</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="n">tzinfo</span><span class="o">=</span><span class="n">Local</span><span class="p">)</span><span class="o">.</span><span class="n">strftime</span><span class="p">(</span><span class="n">dateformat</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">ldat</span> <span class="o">!=</span> <span class="s">&#39;&#39;</span><span class="p">:</span>
                <span class="n">result</span> <span class="o">+=</span> <span class="s">&#39;set label &quot;</span><span class="si">%s</span><span class="s">&quot; at &quot;</span><span class="si">%s</span><span class="s">&quot;, graph -0.3 left</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span>
                    <span class="n">ldat</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_lo</span><span class="o">.</span><span class="n">isoformat</span><span class="p">())</span>
            <span class="k">if</span> <span class="n">rdat</span> <span class="o">!=</span> <span class="n">ldat</span><span class="p">:</span>
                <span class="n">result</span> <span class="o">+=</span> <span class="s">&#39;set label &quot;</span><span class="si">%s</span><span class="s">&quot; at &quot;</span><span class="si">%s</span><span class="s">&quot;, graph -0.3 right</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span>
                    <span class="n">rdat</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span><span class="o">.</span><span class="n">isoformat</span><span class="p">())</span>
        <span class="c"># set bottom margin</span>
        <span class="n">bmargin</span> <span class="o">=</span> <span class="nb">eval</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="n">plot</span><span class="p">,</span> <span class="s">&#39;bmargin&#39;</span><span class="p">,</span> <span class="s">&#39;-1&#39;</span><span class="p">))</span>
        <span class="n">result</span> <span class="o">+=</span> <span class="s">&#39;set bmargin </span><span class="si">%g</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">bmargin</span><span class="p">)</span>
        <span class="c"># set y ranges and tics</span>
        <span class="n">yrange</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="n">plot</span><span class="p">,</span> <span class="s">&#39;yrange&#39;</span><span class="p">,</span> <span class="bp">None</span><span class="p">)</span>
        <span class="n">y2range</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="n">plot</span><span class="p">,</span> <span class="s">&#39;y2range&#39;</span><span class="p">,</span> <span class="bp">None</span><span class="p">)</span>
        <span class="n">ytics</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="n">plot</span><span class="p">,</span> <span class="s">&#39;ytics&#39;</span><span class="p">,</span> <span class="s">&#39;autofreq&#39;</span><span class="p">)</span>
        <span class="n">y2tics</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="n">plot</span><span class="p">,</span> <span class="s">&#39;y2tics&#39;</span><span class="p">,</span> <span class="s">&#39;&#39;</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">y2tics</span> <span class="ow">and</span> <span class="ow">not</span> <span class="n">y2range</span><span class="p">:</span>
            <span class="n">y2range</span> <span class="o">=</span> <span class="n">yrange</span>
        <span class="k">elif</span> <span class="n">y2range</span> <span class="ow">and</span> <span class="ow">not</span> <span class="n">y2tics</span><span class="p">:</span>
            <span class="n">y2tics</span> <span class="o">=</span> <span class="s">&#39;autofreq&#39;</span>
        <span class="k">if</span> <span class="n">yrange</span><span class="p">:</span>
            <span class="n">result</span> <span class="o">+=</span> <span class="s">&#39;set yrange [</span><span class="si">%s</span><span class="s">]</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">yrange</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s">&#39;,&#39;</span><span class="p">,</span> <span class="s">&#39;:&#39;</span><span class="p">))</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">result</span> <span class="o">+=</span> <span class="s">&#39;set yrange [*:*]</span><span class="se">\n</span><span class="s">&#39;</span>
        <span class="k">if</span> <span class="n">y2range</span><span class="p">:</span>
            <span class="n">result</span> <span class="o">+=</span> <span class="s">&#39;set y2range [</span><span class="si">%s</span><span class="s">]</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">y2range</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s">&#39;,&#39;</span><span class="p">,</span> <span class="s">&#39;:&#39;</span><span class="p">))</span>
        <span class="k">if</span> <span class="n">y2tics</span><span class="p">:</span>
            <span class="n">result</span> <span class="o">+=</span> <span class="s">&#39;set ytics nomirror </span><span class="si">%s</span><span class="s">; set y2tics </span><span class="si">%s</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">ytics</span><span class="p">,</span> <span class="n">y2tics</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">result</span> <span class="o">+=</span> <span class="s">&#39;unset y2tics; set ytics mirror </span><span class="si">%s</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">ytics</span><span class="p">)</span>
        <span class="c"># set grid</span>
        <span class="n">result</span> <span class="o">+=</span> <span class="s">&#39;unset grid</span><span class="se">\n</span><span class="s">&#39;</span>
        <span class="n">grid</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="n">plot</span><span class="p">,</span> <span class="s">&#39;grid&#39;</span><span class="p">,</span> <span class="bp">None</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">grid</span> <span class="o">!=</span> <span class="bp">None</span><span class="p">:</span>
            <span class="n">result</span> <span class="o">+=</span> <span class="s">&#39;set grid </span><span class="si">%s</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="n">grid</span>
        <span class="c"># x_lo &amp; x_hi are in local time, data is indexed in UTC</span>
        <span class="n">start</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_lo</span> <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">utcoffset</span>
        <span class="n">stop</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span> <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">utcoffset</span>
        <span class="n">cumu_start</span> <span class="o">=</span> <span class="n">start</span>
        <span class="k">if</span> <span class="n">source</span> <span class="o">==</span> <span class="bp">self</span><span class="o">.</span><span class="n">raw_data</span><span class="p">:</span>
            <span class="n">boxwidth</span> <span class="o">=</span> <span class="mi">240</span>      <span class="c"># assume 5 minute data interval</span>
            <span class="n">start</span> <span class="o">=</span> <span class="n">source</span><span class="o">.</span><span class="n">before</span><span class="p">(</span><span class="n">start</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">source</span> <span class="o">==</span> <span class="bp">self</span><span class="o">.</span><span class="n">hourly_data</span><span class="p">:</span>
            <span class="n">boxwidth</span> <span class="o">=</span> <span class="mi">2800</span>
            <span class="n">start</span> <span class="o">=</span> <span class="n">source</span><span class="o">.</span><span class="n">before</span><span class="p">(</span><span class="n">start</span><span class="p">)</span>
            <span class="n">interval</span> <span class="o">=</span> <span class="n">timedelta</span><span class="p">(</span><span class="n">minutes</span><span class="o">=</span><span class="mi">90</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">source</span> <span class="o">==</span> <span class="bp">self</span><span class="o">.</span><span class="n">monthly_data</span><span class="p">:</span>
            <span class="n">boxwidth</span> <span class="o">=</span> <span class="mi">2800</span> <span class="o">*</span> <span class="mi">24</span> <span class="o">*</span> <span class="mi">30</span>
            <span class="n">interval</span> <span class="o">=</span> <span class="n">timedelta</span><span class="p">(</span><span class="n">days</span><span class="o">=</span><span class="mi">46</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">interval</span> <span class="o">=</span> <span class="n">timedelta</span><span class="p">(</span><span class="n">hours</span><span class="o">=</span><span class="mi">36</span><span class="p">)</span>
            <span class="n">boxwidth</span> <span class="o">=</span> <span class="mi">2800</span> <span class="o">*</span> <span class="mi">24</span>
        <span class="n">boxwidth</span> <span class="o">=</span> <span class="nb">eval</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="n">plot</span><span class="p">,</span> <span class="s">&#39;boxwidth&#39;</span><span class="p">,</span> <span class="nb">str</span><span class="p">(</span><span class="n">boxwidth</span><span class="p">)))</span>
        <span class="n">result</span> <span class="o">+=</span> <span class="s">&#39;set boxwidth </span><span class="si">%d</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="n">boxwidth</span>
        <span class="n">command</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="n">plot</span><span class="p">,</span> <span class="s">&#39;command&#39;</span><span class="p">,</span> <span class="bp">None</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">command</span><span class="p">:</span>
            <span class="n">result</span> <span class="o">+=</span> <span class="s">&#39;</span><span class="si">%s</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="n">command</span>
        <span class="n">stop</span> <span class="o">=</span> <span class="n">source</span><span class="o">.</span><span class="n">after</span><span class="p">(</span><span class="n">stop</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">stop</span><span class="p">:</span>
            <span class="n">stop</span> <span class="o">=</span> <span class="n">stop</span> <span class="o">+</span> <span class="n">timedelta</span><span class="p">(</span><span class="n">minutes</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
        <span class="c"># write data files</span>
        <span class="n">subplots</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">subplot_no</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">subplot_count</span><span class="p">):</span>
            <span class="n">subplot</span> <span class="o">=</span> <span class="n">Record</span><span class="p">()</span>
            <span class="n">subplot</span><span class="o">.</span><span class="n">subplot</span> <span class="o">=</span> <span class="n">subplot_list</span><span class="p">[</span><span class="n">subplot_no</span><span class="p">]</span>
            <span class="n">subplot</span><span class="o">.</span><span class="n">dat_file</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">work_dir</span><span class="p">,</span> <span class="s">&#39;plot_</span><span class="si">%d</span><span class="s">_</span><span class="si">%d</span><span class="s">.dat&#39;</span> <span class="o">%</span> <span class="p">(</span>
                <span class="n">plot_no</span><span class="p">,</span> <span class="n">subplot_no</span><span class="p">))</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">tmp_files</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">subplot</span><span class="o">.</span><span class="n">dat_file</span><span class="p">)</span>
            <span class="n">subplot</span><span class="o">.</span><span class="n">dat</span> <span class="o">=</span> <span class="nb">open</span><span class="p">(</span><span class="n">subplot</span><span class="o">.</span><span class="n">dat_file</span><span class="p">,</span> <span class="s">&#39;w&#39;</span><span class="p">)</span>
            <span class="n">subplot</span><span class="o">.</span><span class="n">xcalc</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="n">subplot</span><span class="o">.</span><span class="n">subplot</span><span class="p">,</span> <span class="s">&#39;xcalc&#39;</span><span class="p">,</span> <span class="bp">None</span><span class="p">)</span>
            <span class="n">subplot</span><span class="o">.</span><span class="n">ycalc</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="n">subplot</span><span class="o">.</span><span class="n">subplot</span><span class="p">,</span> <span class="s">&#39;ycalc&#39;</span><span class="p">,</span> <span class="bp">None</span><span class="p">)</span>
            <span class="n">subplot</span><span class="o">.</span><span class="n">cummulative</span> <span class="o">=</span> <span class="s">&#39;last_ycalc&#39;</span> <span class="ow">in</span> <span class="n">subplot</span><span class="o">.</span><span class="n">ycalc</span>
            <span class="k">if</span> <span class="n">subplot</span><span class="o">.</span><span class="n">xcalc</span><span class="p">:</span>
                <span class="n">subplot</span><span class="o">.</span><span class="n">xcalc</span> <span class="o">=</span> <span class="nb">compile</span><span class="p">(</span><span class="n">subplot</span><span class="o">.</span><span class="n">xcalc</span><span class="p">,</span> <span class="s">&#39;&lt;string&gt;&#39;</span><span class="p">,</span> <span class="s">&#39;eval&#39;</span><span class="p">)</span>
            <span class="n">subplot</span><span class="o">.</span><span class="n">ycalc</span> <span class="o">=</span> <span class="nb">compile</span><span class="p">(</span><span class="n">subplot</span><span class="o">.</span><span class="n">ycalc</span><span class="p">,</span> <span class="s">&#39;&lt;string&gt;&#39;</span><span class="p">,</span> <span class="s">&#39;eval&#39;</span><span class="p">)</span>
            <span class="n">subplot</span><span class="o">.</span><span class="n">last_ycalcs</span> <span class="o">=</span> <span class="mf">0.0</span>
            <span class="n">subplot</span><span class="o">.</span><span class="n">last_idx</span> <span class="o">=</span> <span class="bp">None</span>
            <span class="n">subplots</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">subplot</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">data</span> <span class="ow">in</span> <span class="n">source</span><span class="p">[</span><span class="n">start</span><span class="p">:</span><span class="n">stop</span><span class="p">]:</span>
            <span class="k">for</span> <span class="n">subplot</span> <span class="ow">in</span> <span class="n">subplots</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">subplot</span><span class="o">.</span><span class="n">xcalc</span><span class="p">:</span>
                    <span class="n">idx</span> <span class="o">=</span> <span class="nb">eval</span><span class="p">(</span><span class="n">subplot</span><span class="o">.</span><span class="n">xcalc</span><span class="p">)</span>
                    <span class="k">if</span> <span class="n">idx</span> <span class="ow">is</span> <span class="bp">None</span><span class="p">:</span>
                        <span class="k">continue</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">idx</span> <span class="o">=</span> <span class="n">data</span><span class="p">[</span><span class="s">&#39;idx&#39;</span><span class="p">]</span>
                <span class="n">idx</span> <span class="o">+=</span> <span class="bp">self</span><span class="o">.</span><span class="n">utcoffset</span>
                <span class="k">if</span> <span class="ow">not</span> <span class="n">subplot</span><span class="o">.</span><span class="n">cummulative</span> <span class="ow">and</span> <span class="n">subplot</span><span class="o">.</span><span class="n">last_idx</span><span class="p">:</span>
                    <span class="k">if</span> <span class="n">source</span> <span class="o">==</span> <span class="bp">self</span><span class="o">.</span><span class="n">raw_data</span><span class="p">:</span>
                        <span class="n">interval</span> <span class="o">=</span> <span class="n">timedelta</span><span class="p">(</span><span class="n">minutes</span><span class="o">=</span><span class="p">((</span><span class="n">data</span><span class="p">[</span><span class="s">&#39;delay&#39;</span><span class="p">]</span><span class="o">*</span><span class="mi">3</span><span class="p">)</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span><span class="o">/</span><span class="mi">2</span><span class="p">)</span>
                    <span class="k">if</span> <span class="n">idx</span> <span class="o">-</span> <span class="n">subplot</span><span class="o">.</span><span class="n">last_idx</span> <span class="o">&gt;</span> <span class="n">interval</span><span class="p">:</span>
                        <span class="c"># missing data</span>
                        <span class="n">subplot</span><span class="o">.</span><span class="n">dat</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="s">&#39;</span><span class="si">%s</span><span class="s"> ?</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">idx</span><span class="o">.</span><span class="n">isoformat</span><span class="p">()))</span>
                <span class="n">subplot</span><span class="o">.</span><span class="n">last_idx</span> <span class="o">=</span> <span class="n">idx</span>
                <span class="k">try</span><span class="p">:</span>
                    <span class="k">if</span> <span class="n">subplot</span><span class="o">.</span><span class="n">cummulative</span> <span class="ow">and</span> <span class="n">data</span><span class="p">[</span><span class="s">&#39;idx&#39;</span><span class="p">]</span> <span class="o">&lt;=</span> <span class="n">cumu_start</span><span class="p">:</span>
                        <span class="n">value</span> <span class="o">=</span> <span class="mf">0.0</span>
                    <span class="k">else</span><span class="p">:</span>
                        <span class="n">last_ycalc</span> <span class="o">=</span> <span class="n">subplot</span><span class="o">.</span><span class="n">last_ycalcs</span>
                        <span class="n">value</span> <span class="o">=</span> <span class="nb">eval</span><span class="p">(</span><span class="n">subplot</span><span class="o">.</span><span class="n">ycalc</span><span class="p">)</span>
                    <span class="n">subplot</span><span class="o">.</span><span class="n">dat</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="s">&#39;</span><span class="si">%s</span><span class="s"> </span><span class="si">%g</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">idx</span><span class="o">.</span><span class="n">isoformat</span><span class="p">(),</span> <span class="n">value</span><span class="p">))</span>
                    <span class="n">subplot</span><span class="o">.</span><span class="n">last_ycalcs</span> <span class="o">=</span> <span class="n">value</span>
                <span class="k">except</span> <span class="ne">TypeError</span><span class="p">:</span>
                    <span class="k">if</span> <span class="ow">not</span> <span class="n">subplot</span><span class="o">.</span><span class="n">cummulative</span><span class="p">:</span>
                        <span class="n">subplot</span><span class="o">.</span><span class="n">dat</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="s">&#39;</span><span class="si">%s</span><span class="s"> ?</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">idx</span><span class="o">.</span><span class="n">isoformat</span><span class="p">()))</span>
                    <span class="n">subplot</span><span class="o">.</span><span class="n">last_ycalcs</span> <span class="o">=</span> <span class="mf">0.0</span>
        <span class="k">for</span> <span class="n">subplot</span> <span class="ow">in</span> <span class="n">subplots</span><span class="p">:</span>
            <span class="c"># ensure the data file isn&#39;t empty</span>
            <span class="n">idx</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_hi</span> <span class="o">+</span> <span class="bp">self</span><span class="o">.</span><span class="n">duration</span>
            <span class="n">subplot</span><span class="o">.</span><span class="n">dat</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="s">&#39;</span><span class="si">%s</span><span class="s"> ?</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">idx</span><span class="o">.</span><span class="n">isoformat</span><span class="p">()))</span>
            <span class="n">subplot</span><span class="o">.</span><span class="n">dat</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
        <span class="c"># plot data</span>
        <span class="n">result</span> <span class="o">+=</span> <span class="s">&#39;plot &#39;</span>
        <span class="n">colour</span> <span class="o">=</span> <span class="mi">0</span>
        <span class="k">for</span> <span class="n">subplot_no</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">subplot_count</span><span class="p">):</span>
            <span class="n">subplot</span> <span class="o">=</span> <span class="n">subplots</span><span class="p">[</span><span class="n">subplot_no</span><span class="p">]</span>
            <span class="n">colour</span> <span class="o">=</span> <span class="nb">eval</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="n">subplot</span><span class="o">.</span><span class="n">subplot</span><span class="p">,</span> <span class="s">&#39;colour&#39;</span><span class="p">,</span> <span class="nb">str</span><span class="p">(</span><span class="n">colour</span><span class="o">+</span><span class="mi">1</span><span class="p">)))</span>
            <span class="n">style</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span>
                <span class="n">subplot</span><span class="o">.</span><span class="n">subplot</span><span class="p">,</span> <span class="s">&#39;style&#39;</span><span class="p">,</span> <span class="s">&#39;smooth unique lc </span><span class="si">%d</span><span class="s"> lw 1&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">colour</span><span class="p">))</span>
            <span class="n">words</span> <span class="o">=</span> <span class="n">style</span><span class="o">.</span><span class="n">split</span><span class="p">()</span>
            <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">words</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">1</span> <span class="ow">and</span> <span class="n">words</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="ow">in</span> <span class="p">(</span><span class="s">&#39;+&#39;</span><span class="p">,</span> <span class="s">&#39;x&#39;</span><span class="p">,</span> <span class="s">&#39;line&#39;</span><span class="p">):</span>
                <span class="n">width</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">words</span><span class="p">[</span><span class="mi">1</span><span class="p">])</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">width</span> <span class="o">=</span> <span class="mi">1</span>
            <span class="k">if</span> <span class="n">style</span> <span class="o">==</span> <span class="s">&#39;box&#39;</span><span class="p">:</span>
                <span class="n">style</span> <span class="o">=</span> <span class="s">&#39;lc </span><span class="si">%d</span><span class="s"> lw 0 with boxes&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">colour</span><span class="p">)</span>
            <span class="k">elif</span> <span class="n">words</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">==</span> <span class="s">&#39;+&#39;</span><span class="p">:</span>
                <span class="n">style</span> <span class="o">=</span> <span class="s">&#39;lc </span><span class="si">%d</span><span class="s"> lw </span><span class="si">%d</span><span class="s"> pt 1 with points&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">colour</span><span class="p">,</span> <span class="n">width</span><span class="p">)</span>
            <span class="k">elif</span> <span class="n">words</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">==</span> <span class="s">&#39;x&#39;</span><span class="p">:</span>
                <span class="n">style</span> <span class="o">=</span> <span class="s">&#39;lc </span><span class="si">%d</span><span class="s"> lw </span><span class="si">%d</span><span class="s"> pt 2 with points&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">colour</span><span class="p">,</span> <span class="n">width</span><span class="p">)</span>
            <span class="k">elif</span> <span class="n">words</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">==</span> <span class="s">&#39;line&#39;</span><span class="p">:</span>
                <span class="n">style</span> <span class="o">=</span> <span class="s">&#39;smooth unique lc </span><span class="si">%d</span><span class="s"> lw </span><span class="si">%d</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">colour</span><span class="p">,</span> <span class="n">width</span><span class="p">)</span>
            <span class="n">axes</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="n">subplot</span><span class="o">.</span><span class="n">subplot</span><span class="p">,</span> <span class="s">&#39;axes&#39;</span><span class="p">,</span> <span class="s">&#39;x1y1&#39;</span><span class="p">)</span>
            <span class="n">title</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">GetValue</span><span class="p">(</span><span class="n">subplot</span><span class="o">.</span><span class="n">subplot</span><span class="p">,</span> <span class="s">&#39;title&#39;</span><span class="p">,</span> <span class="s">&#39;&#39;</span><span class="p">)</span>
            <span class="n">result</span> <span class="o">+=</span> <span class="s">&#39; &quot;</span><span class="si">%s</span><span class="s">&quot; using 1:($2) axes </span><span class="si">%s</span><span class="s"> title &quot;</span><span class="si">%s</span><span class="s">&quot; </span><span class="si">%s</span><span class="s">&#39;</span> <span class="o">%</span> <span class="p">(</span>
                <span class="n">subplot</span><span class="o">.</span><span class="n">dat_file</span><span class="p">,</span> <span class="n">axes</span><span class="p">,</span> <span class="n">title</span><span class="p">,</span> <span class="n">style</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">subplot_no</span> <span class="o">!=</span> <span class="n">subplot_count</span> <span class="o">-</span> <span class="mi">1</span><span class="p">:</span>
                <span class="n">result</span> <span class="o">+=</span> <span class="s">&#39;, </span><span class="se">\\</span><span class="s">&#39;</span>
            <span class="n">result</span> <span class="o">+=</span> <span class="s">&#39;</span><span class="se">\n</span><span class="s">&#39;</span>
        <span class="n">result</span> <span class="o">=</span> <span class="n">result</span><span class="o">.</span><span class="n">encode</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">encoding</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">result</span>
</div></div>
<div class="viewcode-block" id="main"><a class="viewcode-back" href="../../api/pywws.Plot.html#pywws.Plot.main">[docs]</a><span class="k">def</span> <span class="nf">main</span><span class="p">(</span><span class="n">argv</span><span class="o">=</span><span class="bp">None</span><span class="p">):</span>
    <span class="k">if</span> <span class="n">argv</span> <span class="ow">is</span> <span class="bp">None</span><span class="p">:</span>
        <span class="n">argv</span> <span class="o">=</span> <span class="n">sys</span><span class="o">.</span><span class="n">argv</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">opts</span><span class="p">,</span> <span class="n">args</span> <span class="o">=</span> <span class="n">getopt</span><span class="o">.</span><span class="n">getopt</span><span class="p">(</span><span class="n">argv</span><span class="p">[</span><span class="mi">1</span><span class="p">:],</span> <span class="s">&quot;h&quot;</span><span class="p">,</span> <span class="p">[</span><span class="s">&#39;help&#39;</span><span class="p">])</span>
    <span class="k">except</span> <span class="n">getopt</span><span class="o">.</span><span class="n">error</span><span class="p">,</span> <span class="n">msg</span><span class="p">:</span>
        <span class="k">print</span> <span class="o">&gt;&gt;</span><span class="n">sys</span><span class="o">.</span><span class="n">stderr</span><span class="p">,</span> <span class="s">&#39;Error: </span><span class="si">%s</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="n">msg</span>
        <span class="k">print</span> <span class="o">&gt;&gt;</span><span class="n">sys</span><span class="o">.</span><span class="n">stderr</span><span class="p">,</span> <span class="n">__doc__</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
        <span class="k">return</span> <span class="mi">1</span>
    <span class="c"># process options</span>
    <span class="k">for</span> <span class="n">o</span><span class="p">,</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">opts</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">o</span> <span class="o">==</span> <span class="s">&#39;-h&#39;</span> <span class="ow">or</span> <span class="n">o</span> <span class="o">==</span> <span class="s">&#39;--help&#39;</span><span class="p">:</span>
            <span class="k">print</span> <span class="n">__doc__</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
            <span class="k">return</span> <span class="mi">0</span>
    <span class="c"># check arguments</span>
    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">args</span><span class="p">)</span> <span class="o">!=</span> <span class="mi">4</span><span class="p">:</span>
        <span class="k">print</span> <span class="o">&gt;&gt;</span><span class="n">sys</span><span class="o">.</span><span class="n">stderr</span><span class="p">,</span> <span class="s">&#39;Error: 4 arguments required</span><span class="se">\n</span><span class="s">&#39;</span>
        <span class="k">print</span> <span class="o">&gt;&gt;</span><span class="n">sys</span><span class="o">.</span><span class="n">stderr</span><span class="p">,</span> <span class="n">__doc__</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
        <span class="k">return</span> <span class="mi">2</span>
    <span class="n">params</span> <span class="o">=</span> <span class="n">DataStore</span><span class="o">.</span><span class="n">params</span><span class="p">(</span><span class="n">args</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
    <span class="n">Localisation</span><span class="o">.</span><span class="n">SetApplicationLanguage</span><span class="p">(</span><span class="n">params</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">GraphPlotter</span><span class="p">(</span>
        <span class="n">params</span><span class="p">,</span>
        <span class="n">DataStore</span><span class="o">.</span><span class="n">calib_store</span><span class="p">(</span><span class="n">args</span><span class="p">[</span><span class="mi">0</span><span class="p">]),</span> <span class="n">DataStore</span><span class="o">.</span><span class="n">hourly_store</span><span class="p">(</span><span class="n">args</span><span class="p">[</span><span class="mi">0</span><span class="p">]),</span>
        <span class="n">DataStore</span><span class="o">.</span><span class="n">daily_store</span><span class="p">(</span><span class="n">args</span><span class="p">[</span><span class="mi">0</span><span class="p">]),</span> <span class="n">DataStore</span><span class="o">.</span><span class="n">monthly_store</span><span class="p">(</span><span class="n">args</span><span class="p">[</span><span class="mi">0</span><span class="p">]),</span>
        <span class="n">args</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
        <span class="p">)</span><span class="o">.</span><span class="n">DoPlot</span><span class="p">(</span><span class="n">args</span><span class="p">[</span><span class="mi">2</span><span class="p">],</span> <span class="n">args</span><span class="p">[</span><span class="mi">3</span><span class="p">])</span>
</div>
<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s">&quot;__main__&quot;</span><span class="p">:</span>
    <span class="n">sys</span><span class="o">.</span><span class="n">exit</span><span class="p">(</span><span class="n">main</span><span class="p">())</span>
</pre></div>

          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none">
  <h3>Quick search</h3>
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" size="18" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li><a href="../../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="../index.html" >Module code</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2009-12, Jim Easterbrook.
      Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.0.1.
    </div>
  </body>
</html>